//////////////////////////////////////////////////////////////////////
//	$$root$$.cpp - a minimal external module for NeatTools
//                     generated by Rob Salgado's ModuleMaker
//
//
//////////////////////////////////////////////////////////////////////

#include "$$root$$.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JLinkObj.h"

#include <stdio.h>
#include <malloc.h>
#include <string.h>

/*------------------------------------------------------------------------*/
//
//	Register() registers the module with NeatTools
//
char* the$$root$$ = $$root$$().Register();

/*------------------------------------------------------------------------*/
//
void $$root$$::writeContent(JOutputStream& os) {
	
	//call base-class writeContent() first
	JAddObj::writeContent(os);	
  
	//write a table of "persistent variables", 
	//which comprise the "state" of this instance of the module
 	putInteger(os, "persistentInteger1", persistentInteger1);
}

/*------------------------------------------------------------------------*/
//
void $$root$$::readContent(JDictionary& dict) {

	//call base-class readContent() first
	JAddObj::readContent(dict);	
  
	//read a table of "persistent variables", 
	//which comprise the "state" of this instance of the module
	persistentInteger1= getInteger(dict, "persistentInteger1");
}

/*------------------------------------------------------------------------*/
//
//	className() returns the name of the module
//
const char* $$root$$::className() const { return "$$root$$";}

/*------------------------------------------------------------------------*/
//
//	clone() is used to instantiate copies of the module
//
JObject* $$root$$::clone() const { return new $$root$$(*this);}

/*------------------------------------------------------------------------*/
//
//	Constructor method
//
$$root$$::$$root$$() {

	igm = 1;	// current input-port number (declared in JModuleObj)
	doRepaint = false;

	moduleColor=JColor::green.brighter();	

	persistentInteger1=0;	//initial value of persistentInteger1
}


/*------------------------------------------------------------------------*/
//
//	paint() method is called by the system
//
void $$root$$::paint(JGraphics g, double dx, double dy, 
								JRegion& rgn, double scale) {

  g.setJColor(moduleColor);
  JRect rect = getIExtent(dx, dy, scale);
  g.fill3DRect(rect.x, rect.y, rect.width, rect.height, 3);

}

/*------------------------------------------------------------------------*/
boolean $$root$$::inputAllowed(int n){ 
	return !inputSet(n).last();
}
/*------------------------------------------------------------------------*/
JString $$root$$::inputTag(int n) {
	char* tag[] = { "input"};
	return tag[n];
}
/*------------------------------------------------------------------------*/
JString $$root$$::outputTag(int n) {	
	char* tag[] = { "output" };
	return tag[n];
}
/*------------------------------------------------------------------------*/
JFRect $$root$$::inputArea(int n) { 
	return leftArea(n, 0, 1);
}
/*------------------------------------------------------------------------*/
JFRect $$root$$::outputArea(int n) { 
  return rightArea(n, 0, 1);
}
/*------------------------------------------------------------------------*/
int $$root$$::inputFace(int n) { 
	return LEFT;
}
/*------------------------------------------------------------------------*/
int $$root$$::outputFace(int n) { 
	return RIGHT;
}
/*------------------------------------------------------------------------*/
JFPoint $$root$$::inputPoint(int n, JLinkObj& link) { 
	return leftPoint(n, link, 0, 1);	
}
/*------------------------------------------------------------------------*/
JFPoint $$root$$::outputPoint(int n, JLinkObj& link) { 
	return rightPoint(n, link, 0, 1);
}

/*------------------------------------------------------------------------*/
//
// engine() is called when an input-event is detected
//
void $$root$$::engine(int n, JLinkObj& link) {
	int nv;
	
	link.access(JIntegerData(nv));	//call the input-link's access() method
	
	if (persistentInteger1!=nv) {
		moduleColor=JColor(nv,0);
		persistentInteger1=nv;
		repaint();
		broadcast(0);
	}
}

/*------------------------------------------------------------------------*/
//
// access() may be called by an output-link engine() method 
//		when we do a broadcast()
//
void $$root$$::access(int n, JLinkObj& link, const JDataType& data) {
	INT(data)=persistentInteger1;
}
		

/*------------------------------------------------------------------------*/
//
// getProperties() produces a list of properties
//
JArray $$root$$::getProperties() {
  JArray properties;

	//	format:  
	//	J_x_Property(VARIABLE_TAG, PERSISTENT_VARIABLE, MIN_LABEL, MAX_LABEL)
	properties.append(
		JIntegerProperty("Persistent Integer #1", persistentInteger1, 1, 1000)
	);


  return properties;
}

/*------------------------------------------------------------------------*/
//
// updateProperty() updates a given property, as specified by VARIABLE_LABEL
//
boolean $$root$$::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("Persistent Integer #1")) {
	  persistentInteger1 = ((JIntegerProperty*)&prop)->value;	//do update
	  return true;	//leave and announce that the property was found
  }

  return false;	//leave and announce that the property was not found
}

/*------------------------------------------------------------------------*/
